package org.pnml.tools.epnk.gmf.integration.helpers;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.pnml.tools.epnk.pnmlcoremodel.Page;
import org.pnml.tools.epnk.toolspecific.diagraminfo.DiagramInfo;
import org.pnml.tools.epnk.toolspecific.diagraminfo.util.DiagramInfoHelper;

// @generated NOt
// @author eki
public class OpenGMFEditor {

	/**
	 * Opens a GMF diagram editor on the page. If an editor is open on this
	 * page already, it will become active; but no new one will be opened.
	 *  
	 * @param page
	 * @return whether the open operation was successful
	 */
	public static boolean open(Page page) {
		DiagramInfo diagramextension = DiagramInfoHelper.getDiagramInfo(page);
		if (diagramextension == null) {
			boolean result =
				MessageDialog.openConfirm(
						null,
						"ePNK: Create Diagram Information Extension",
						"There is no diagram for this net yet. It will be created now. " +
						"Note that, if you proceed, you cannot do any undo operation before " +
						"this point. Do you want to proceed?"
				);
			if (!result) {
				return false;
			}
		}

		IWorkbenchPage workbenchPage = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
		try {
			PNMLPageEditorInput input = new PNMLPageEditorInput(page);
			workbenchPage.openEditor( input, "org.pnml.tools.epnk.diagram.part.PNMLCoreModelDiagramEditorID");
		} catch (PartInitException e) {
			return false;
		}

		return true;	
	}

}
